function xdot = benzene_pyrol_rhs(volume,x,p)
    ext1 = x(1);
    ext2 = x(2);

    NB = p.NBf - 2*ext1 - ext2;
    ND = ext1 - ext2;
    NH = ext1 + ext2;
    NT = ext2;

    Q = p.NBf*p.R*p.T/p.P;

    cB = NB/Q;
    cD = ND/Q;
    cT = NT/Q;
    cH = NH/Q;

    xdot = [p.k1*(cB*cB - cD*cH/p.K1);
            p.k2*(cB*cD - cT*cH/p.K2)];