function dNdv = rxrate(v,x,p)
    N1 = x(1);
    N2 = x(2);
    N3 = x(3);
    N4 = x(4);
    N5 = x(5);
    N6 = x(6);
    N7 = x(7);

    Ntot = N1 + N2 + N3 + N4 + N5 + N6 + N7;
    Ctot = p.P/(p.R1*p.T);
    C1 = (N1/Ntot)*Ctot;
    C2 = (N2/Ntot)*Ctot;
    C3 = (N3/Ntot)*Ctot;
    C4 = (N4/Ntot)*Ctot;
    C5 = (N5/Ntot)*Ctot;

    r1 = p.k(1)*C1*C2;
    r2 = p.k(2)*C3;
    r3 = p.k(3)*C1*C5;
    r4 = p.k(4)*C2*C5;
    r5 = p.k(5)*C4;
    r6 = p.k(6)*C3*C4;

    dNdv = zeros (7, 1);

    dNdv(1) = -r1 - r3 + r6;
    dNdv(2) = -r1 -r4 + r5 +r6;
    dNdv(3) = r1  -r2 + r3 -r6;
    dNdv(4) = r1 +r4 -r5 -r6;
    dNdv(5) = r2 -r3 -r4 + r5;
    dNdv(6) = r2;
    dNdv(7) = r3;