function [dcadr, dcbdr, dccdr] = dcdr_calc(x, p)
    za = x(1:p.npts);
    zb = x(p.npts+1:2*p.npts);
    zc = x(2*p.npts+1:3*p.npts);

    ca = exp(za);
    cb = exp(zb);
    cc = exp(zc);

    dzadr = p.col.A(p.npts,:)*za;
    dzbdr = p.col.A(p.npts,:)*zb;
    dzcdr = p.col.A(p.npts,:)*zc;

    dcadr = dzadr.*ca;
    dcbdr = dzbdr.*cb;
    dccdr = dzcdr.*cc;