function retval = pellet(x, p)
    za = x(1:p.npts);
    zb = x(p.npts+1:2*p.npts);
    zc = x(2*p.npts+1:3*p.npts);
    ca = exp(za);
    cb = exp(zb);
    cc = exp(zc);

    k1      = p.k.k10*exp(-p.k.E1/p.T);
    k2      = p.k.k20*exp(-p.k.E2/p.T);
    Ka      = p.k.Ka0*exp(-p.k.Ea/p.T);
    Kc      = p.k.Kc0*exp(-p.k.Ec/p.T);
    den     = (1 + Ka*ca + Kc*cc).^2;
    r1      = k1.*ca.*cb./den;
    r2      = k2*cc.*cb./den;
    Ra      = - r1;
    Rb      = - 1/2*r1  - 9/2*r2;
    Rc      = - r2;

    % component A
    ip = 1;
    retval(ip) = p.col.A(1,:)*za;
    caint = ca(2:p.npts-1);
    retval(ip+1:ip+p.npts-2) = p.col.Bint*za + p.col.Aint*za.*...
                                 (p.col.Aint*za + 2./p.col.Rint) + ...
                                 Ra(2:p.npts-1)./(p.D.a*caint);
    dzadr = p.col.A(p.npts,:)*za;
    retval(ip+p.npts-1) = p.D.a*dzadr - p.km.a*(p.cf.a/ca(p.npts) - 1);

    % component B
    ip = p.npts + 1;
    cbint = cb(2:p.npts-1);
    retval(ip) = p.col.A(1,:)*zb;
    retval(ip+1:ip+p.npts-2) = p.col.Bint*zb + p.col.Aint*zb.*...
                                 (p.col.Aint*zb + 2./p.col.Rint) + ...
                                 Rb(2:p.npts-1)./(p.D.b*cbint);
    dzbdr = p.col.A(p.npts,:)*zb;
    retval(ip+p.npts-1) =  p.D.b*dzbdr - p.km.b*(p.cf.b/cb(p.npts) - 1);

    % component C
    ip = 2*p.npts + 1;
    ccint = cc(2:p.npts-1);
    retval(ip) = p.col.A(1,:)*zc;
    retval(ip+1:ip+p.npts-2) = p.col.Bint*zc + p.col.Aint*zc.*...
                            (p.col.Aint*zc + 2./p.col.Rint) + ...
                            Rc(2:p.npts-1)./(p.D.c*ccint);
    dzcdr = p.col.A(p.npts,:)*zc;
    retval(ip+p.npts-1) = p.D.c*dzcdr - p.km.c*(p.cf.c/cc(p.npts) - 1);

    dcadr = dzadr.*ca;
    dcbdr = dzbdr.*cb;
    dccdr = dzcdr.*cc;