function res = bed(t, y, ydot, p)
  Naf = y(1);
  Nbf = y(2);
  Ncf = y(3);
  T   = y(4);
  P   = y(5);
  zpellet = y(6:length(y));
  % update parameter struct before calling pellet
  Ntf  = p.Ntfin -1/2*(p.Nafin - Naf) + 1/2*(p.Ncfin - Ncf);
  Q  = p.Qin * p.Pin/P*T/p.Tin*Ntf/p.Ntfin;
  caf = Naf/Q;
  cbf = Nbf/Q;
  ccf = Ncf/Q;
  % update the fluid parameters and call pellet
  p.caf = caf; p.cbf = cbf; p.ccf = ccf; p.Q = Q; p.T = T;

  % calculate pellet residual and update
  % total pellet reaction rate through dcadr dcbdr dccdr
  [pelletres, pelletrate] = pelletfull(zpellet, p);
  dcadr = pelletrate(1); dcbdr=pelletrate(2); dccdr = pelletrate(3);
  r1p   = p.Da/p.a*dcadr;
  r2p   = p.Dc/p.a*dccdr;

  Rj    = -(1-p.epsb)/p.a*[ p.Da*dcadr; p.Db*dcbdr; p.Dc*dccdr];
  dT    = ( -(p.delH1*r1p + p.delH2*r2p) + 2/p.Rt*p.U*(p.Ta-T) ) / p.Cptot;
%  dT    = 0;
  dP    = - (1-p.epsb)*Q / ( 2*p.Rp*p.epsb^3.*p.Ac^2. ) * ...
          ( 150*(1-p.epsb)*p.vis/(2*p.Rp) + 7/4*p.massf/p.Ac );
%  dP = 0;
  rhs = [Rj; dT; dP];
  res(1:5,1) = ydot(1:5) - rhs;
  res(6:length(y)) = pelletres;