function res = tworeac(x, p)
    ca1 = x(1);
    cb1 = x(2);
    ca2 = x(3);
    cb2 = x(4);

    r11 = p.k1*ca1*cb1;
    r21 = p.k2*ca1^p.n;
    r12 = p.k1*ca2*cb2;
    r22 = p.k2*ca2^p.n;

    R = [ -(r11 + r21)*p.theta1;
          -r11*p.theta1;
          -(r12 + r22)*p.theta2;
          -r12*p.theta2];

    flow = [p.alpha*p.caf - (p.alpha + p.rho)*ca1 + p.rho*ca2;
          -(p.alpha + p.rho)*cb1 + p.rho*cb2;
          -(1 + p.alpha)*ca2 + (p.alpha + p.rho)*ca1 - p.rho*ca2;
           p.cbf + (p.alpha + p.rho)*cb1 - ...
                p.rho*cb2 - (1 + p.alpha)*cb2 ];
    res = flow + R;